using System;
using System.Collections.Generic;
using System.Text;

namespace RDGen
{
   public static   class DataBuilder
    {

       public static  string _binary = "binary";
       public static  string _bigint = "bigint";
       public static  string _bit ="bit";
       public static  string _char ="char";
       public static  string _datetime = "datetime";
       public static  string _decimal = "decimal";
       public static string _float = "float";
       public static  string _image = "image";
       public static  string _int = "int"; 
       public static string _money = "money";
       public static string _nchar = "nchar"; 
       public static  string _ntext = "ntext";
       public static string _nvarchar = "nvarchar";
       public static string _numeric = "numeric";
       public static string _real = "real";
       public static  string _smalldatetime = "smalldatetime";
       public static  string _smallint = "smallint";
       public static string _smallmoney = "smallmoney";
       public static  string _sql_variant = "sql_variant";
       public static  string _sysname = "sysname";
       public static  string _text = "text";
       public static  string _timestamp = "timestamp";
       public static  string _tinyint = "tinyint";
       public static  string _varbinary = "varbinary"; 
       public static string _varchar = "varchar";
       public static  string _uniqueidentifier = "uniqueidentifier";
       public static RandomGenerator DataGenerator = new RandomGenerator(); 
       public static string GetBinary(Column TableColumn)
       {
           string ColumnValue = "CAST( '";
           ColumnValue = ColumnValue + DataGenerator.GetChar();
           ColumnValue = ColumnValue + "'";
           ColumnValue = ColumnValue + "   AS BINARY)";
           return ColumnValue;

       }

       public static string GetBit()
       {
           string ColumnValue = "";
           Random BitRandom = new Random();
           ColumnValue = BitRandom.Next(0,1).ToString();
           return ColumnValue;

       }



       public static string GetBigInt(Column TableColumn)
       {
           string ColumnValue = "";
           Random Length = new Random();
           int DataLength = Length.Next(1, System.Int64.MaxValue.ToString().Length);
           
           for (int i = 1; i <= DataLength; i++)
           {
               ColumnValue = ColumnValue + DataGenerator.GetInt();
           }
           return ColumnValue;
       }
       
       public static string GetChar(Column TableColumn)
       {

           string ColumnValue = "'";
           Random Length = new Random();
           int DataLength = Convert.ToInt32(Length.Next(1,TableColumn.Length));
           
           for (int i = 1; i <= DataLength; i++)
           {
               ColumnValue = ColumnValue + DataGenerator.GetChar();
           }
           ColumnValue = ColumnValue + "'";
           return ColumnValue;
       }

       public static string GetDateTime()
       {

           string ColumnValue = "'";
           
           ColumnValue = ColumnValue + DataGenerator.GetDay();
           ColumnValue = ColumnValue + "-";
           ColumnValue = ColumnValue + DataGenerator.GetMonth();
           ColumnValue = ColumnValue + "-";
           ColumnValue = ColumnValue + DataGenerator.GetYear();
           ColumnValue = ColumnValue + "'";
           return ColumnValue;
       }
        
       public static string GetInt(Column TableColumn)
       {
           string ColumnValue = "";
           Random Length = new Random();
           int DataLength = Length.Next(1, int.MaxValue.ToString().Length);
           
           for (int i = 1; i <= DataLength; i++)
           {
               ColumnValue = ColumnValue + DataGenerator.GetInt();
           }
           return ColumnValue;
       }
 
       
       public static string GetTinyInt()
       {
           
           return DataGenerator.GetTinyInt();
       }

       public static string GetSmallInt(Column TableColumn)
       {
           string ColumnValue = "";
           Random Length = new Random();
           int DataLength = Length.Next(1, System.Int16.MaxValue.ToString().Length);
           
           for (int i = 1; i <= DataLength; i++)
           {
               ColumnValue = ColumnValue + DataGenerator.GetInt();
           }
           return ColumnValue;
       }

       public static string GetText(Column TableColumn)
       {

           string ColumnValue = "'";
               
           
           for (int i = 1; i <= 500; i++)
           {
               ColumnValue = ColumnValue + DataGenerator.GetChar();
           }
           ColumnValue = ColumnValue + "'";
           return ColumnValue;
       }

   }
}
    